
public class Graph {
	public static void main(String[] args) {
		// Undirected Graph, all reachable
		boolean[][] undir = {{false, true, true, false, false},
							 {true, false, false, false, true},
							 {true, false, false, false, false},
							 {false, false, false, false, true},
							 {false, true, false, true, false}};
		
		// Directed Graph
		boolean[][] dir = {{false, true, false, false, false},
						   {true, false, false, false, true},
						   {true, false, false, false, false},
						   {false, false, false, false, true},
						   {false, true, false, false, false}};
		
		System.out.println("Undirected: " + isUndirected(undir));
		print(undir);
		
		System.out.println();
		
		System.out.println("Undirected: " + isUndirected(dir));
		print(dir);
		
		System.out.println();
		
		// ---------------------------------------------------
		
		// Undirected Graph, D not reachable
		boolean[][] undir2 = {{false, true, true, false, false},
							  {true, false, false, false, true},
							  {true, false, false, false, false},
							  {false, false, false, false, false},
							  {false, true, false, false, false}};
		
		System.out.println(allReachable(undir, 0));
		System.out.println(allReachable(undir2, 0));
	}
	
	public static boolean isUndirected(boolean[][] amx) {
		for(int i = 0; i < amx.length; i++) {		// Zeilen
			for(int j = 0; j < i; j++) {			// Spalten
				if(amx[i][j] != amx[j][i])
					return false;
			}
		}

		return true;
	}
	
	public static boolean allReachable(boolean[][] ug, int node) {
		boolean[] visited = new boolean[ug.length];
		
		visited[node] = true;
		visitAll(ug, visited, node);
		
		for(int i = 0; i < visited.length; i++) {
			if(!visited[i])
				return false;
		}
		
		return true;
	}
	
	private static void visitAll(boolean[][] ug, boolean[] visited, int node) {
		for(int i = 0; i < ug.length; i++) {
			if(ug[node][i]) {
				if(!visited[i]) {
					visited[i] = true;
					visitAll(ug, visited, i);
				}
			}
		}
	}
	
	private static void print(boolean[][] matrix) {
		for(int i = 0; i < matrix.length; i++) {
			for(int j = 0; j < matrix[0].length; j++) {
				System.out.print(matrix[i][j] + " ");
			}
			System.out.println();
		}
	}
}
